%%
%% appmfinfofactory.tex
%% $Id: appmfinfofactory.tex,v 1.6 2003-03-07 10:01:20 baurma Exp $
%%

\section{JNukeMFInfoFactory}

\texttt{JNukeMFInfoFactory} is a factory object to create \texttt{JNukeMFInfo} 
objects from method/field object templates. The factory uses a constant pool 
object and an attribute factor object to accomplish this task. It is primarily 
used by the class writer.

%% ------------------------------------------------------------------

\subsection{Constructor}

\code{
JNukeObj * \\
JNukeMFInfoFactory\_new ( \\
\tab	JNukeMem * mem \\
)
}

\subsubsection{Description}

Create a new instance of a \texttt{JNukeMFInfoFactory} object. The memory
required for this operation is drawn from a memory manager object given
as a parameter.

\subsubsection{Parameters}

\begin{description}
\ttitem{mem}
	A reference to a memory manager object.
\end{description}


\subsubsection{Return value}

A new reference to an instance of a \texttt{JNukeMFInfoFactory} object.

%% ------------------------------------------------------------------

\subsection{JNukeMFInfoFactory\_setConstantPool}

\code{
void \\
JNukeMFInfoFactory\_setConstantPool ( \\
\tab	JNukeObj * this, \\
\tab	const JNukeObj * cp \\
)
}

\subsubsection{Description}

Set constant pool associated with this factory. The constant pool is
normally used to insert new entries, such as the names of 
\texttt{method\_info} or \texttt{field\_info} attributes. The current
constant pool object registered with this factory object can be queried
using the \texttt{JNukeMFInfoFactory\_getConstantPool} function.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the factory object whose constant pool should
	be set.
\ttitem{cp}
	Reference to the constant pool object to be used in the future
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeMFInfoFactory\_getConstantPool}

\code{
JNukeObj * \\
JNukeMFInfoFactory\_getConstantPool ( \\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Get constant pool associated with this factory object. To set the constant
pool, the function \\
\texttt{JNukeMFInfoFactory\_setConstantPool} may be used.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the factory object whose constant pool should be
	returned.
\end{description}


\subsubsection{Return value}

A reference to the constant pool associated with this factory or
\texttt{NULL} if there is no constant pool set.

%% ------------------------------------------------------------------

\subsection{JNukeMFInfoFactory\_setAttributeFactory}

\code{
void \\
JNukeMFInfoFactory\_setAttributeFactory ( \\
\tab	JNukeObj * this, \\
\tab	const JNukeObj * af \\
)
}

\subsubsection{Description}

Set the attribute factory property of the \texttt{JNukeMFInfoFactory}.
The attribute factory is used to create new attributes, such as the
\texttt{Code} attribute of a method as described in  \cite[4.7.3]{javavm}. 
The current attribute factory setting may be obtained using the 
\texttt{JNukeMFInfoFactory\_getAttributeFactory} function.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the \texttt{JNukeMFInfoFactory} object whose
	attribute factory property should be returned.
\ttitem{af}
	The reference to the new attribute factory to be used.
\end{description}


\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeMFInfoFactory\_getAttributeFactory}

\code{
JNukeObj * \\
JNukeMFInfoFactory\_getAttributeFactory ( \\
\tab	JNukeObj * this \\
)
}

\subsubsection{Description}

Get attribute factory registered with this object. The attribute factory
may be set using the \\
\texttt{JNukeAttributeFactory\_setAttributeFactory} function.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the object whose attribute factory should be
	returned.
\end{description}

\subsubsection{Return value}

The attribute factory associated with this object or \texttt{NULL} if
the attribute factory property is not set.

%% ------------------------------------------------------------------

\subsection{JNukeMFInfoFactory\_createMethodInfo}

\code{
JNukeObj * \\
JNukeMFInfoFactory\_createMethodInfo( \\
\tab	JNukeObj * this, \\
\tab	const JNukeObj * method \\
)
}

\subsubsection{Description}

Create a \texttt{method\_info} structure of a class file using the internal
representation of a method as a template. This data structure is described 
in \cite[Section~4.6]{javavm}.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the \texttt{JNukeMFInfoFactory} object that should
	create the data structure.
\ttitem{method}
	Reference to an object of type \texttt{JNukeMethodDesc} that should
	act as a template
\end{description}


\subsubsection{Return value}

A reference to a new object of type \texttt{JNukeMFInfo} containing the
desired \texttt{method\_info} data structure.

%% ------------------------------------------------------------------

\subsection{JNukeMFInfoFactory\_createFieldInfo}

\code{
JNukeObj * \\
JNukeMFInfoFactory\_createFieldInfo ( \\
\tab	JNukeObj * this, \\
\tab	const JNukeObj * field \\
)
}

\subsubsection{Description}

Create a \texttt{field\_info} structure of a class file using the internal
representation of a variable as a template. This data structure is 
described in \cite[Section~4.5]{javavm}.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the \texttt{JNukeMFInfoFactory} factory object that 
	should create the data structure.
\ttitem{field}
	Reference to an object of type \texttt{JNukeVarDesc} that should
	act as a template for the content of the data structure.
\end{description}

\subsubsection{Return value}

A reference to a new object of type \texttt{JNukeMFInfo} containing the
desired \texttt{field\_info} data structure.

%% ------------------------------------------------------------------

